# coding: utf-8

"""
    IBM Domino Data API

    The data API provides access to any database for which it is enabled. The API represents databases, views, view entries, and documents in JSON format.  **Important**: This version of the OpenAPI spec (**data.yaml**) includes data API changes from the XPages Extension Library release 9.0.1.v09_02. This  includes new operations on attachments, agents and forms.  If you are using a version before 9.0.1.v09_02, consider using an earlier version of the spec.   # noqa: E501

    OpenAPI spec version: 9.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from dda.api_client import ApiClient


class DocumentListApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def folder_database_api_data_documents_get(self, folder, database, **kwargs):  # noqa: E501
        """Gets a list of documents.    # noqa: E501

        If you don't specify any query parameters,  the response includes all the documents in the database. To limit the number of documents returned, use the optional  `since` or `search` parameters.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.folder_database_api_data_documents_get(folder, database, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str folder: Database folder name relative to the Domino data directory.  If the database is not in a folder, use `.` to specify the data directory itself.  (required)
        :param str database: Database file name. (required)
        :param str search: Returns only documents that match a full-text query. An error occurs if the database is not full-text indexed. 
        :param int searchmaxdocs: Limits the number of documents returned by a full-text search. 
        :param str since: Returns only documents modified since a specified time. Specify the time in ISO 8601 format.  For example, `2011-08-21T20:21:00Z`. 
        :return: DocumentListResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.folder_database_api_data_documents_get_with_http_info(folder, database, **kwargs)  # noqa: E501
        else:
            (data) = self.folder_database_api_data_documents_get_with_http_info(folder, database, **kwargs)  # noqa: E501
            return data

    def folder_database_api_data_documents_get_with_http_info(self, folder, database, **kwargs):  # noqa: E501
        """Gets a list of documents.    # noqa: E501

        If you don't specify any query parameters,  the response includes all the documents in the database. To limit the number of documents returned, use the optional  `since` or `search` parameters.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.folder_database_api_data_documents_get_with_http_info(folder, database, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str folder: Database folder name relative to the Domino data directory.  If the database is not in a folder, use `.` to specify the data directory itself.  (required)
        :param str database: Database file name. (required)
        :param str search: Returns only documents that match a full-text query. An error occurs if the database is not full-text indexed. 
        :param int searchmaxdocs: Limits the number of documents returned by a full-text search. 
        :param str since: Returns only documents modified since a specified time. Specify the time in ISO 8601 format.  For example, `2011-08-21T20:21:00Z`. 
        :return: DocumentListResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['folder', 'database', 'search', 'searchmaxdocs', 'since']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method folder_database_api_data_documents_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'folder' is set
        if self.api_client.client_side_validation and ('folder' not in params or
                                                       params['folder'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `folder` when calling `folder_database_api_data_documents_get`")  # noqa: E501
        # verify the required parameter 'database' is set
        if self.api_client.client_side_validation and ('database' not in params or
                                                       params['database'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `database` when calling `folder_database_api_data_documents_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'folder' in params:
            path_params['folder'] = params['folder']  # noqa: E501
        if 'database' in params:
            path_params['database'] = params['database']  # noqa: E501

        query_params = []
        if 'search' in params:
            query_params.append(('search', params['search']))  # noqa: E501
        if 'searchmaxdocs' in params:
            query_params.append(('searchmaxdocs', params['searchmaxdocs']))  # noqa: E501
        if 'since' in params:
            query_params.append(('since', params['since']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['basic']  # noqa: E501

        return self.api_client.call_api(
            '/{folder}/{database}/api/data/documents', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DocumentListResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
