# coding: utf-8

"""
    IBM Domino Data API

    The data API provides access to any database for which it is enabled. The API represents databases, views, view entries, and documents in JSON format.  **Important**: This version of the OpenAPI spec (**data.yaml**) includes data API changes from the XPages Extension Library release 9.0.1.v09_02. This  includes new operations on attachments, agents and forms.  If you are using a version before 9.0.1.v09_02, consider using an earlier version of the spec.   # noqa: E501

    OpenAPI spec version: 9.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from dda.configuration import Configuration


class DocumentListEntry(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'modified': 'str',
        'unid': 'str',
        'href': 'str',
        'score': 'int'
    }

    attribute_map = {
        'modified': '@modified',
        'unid': '@unid',
        'href': '@href',
        'score': '@score'
    }

    def __init__(self, modified=None, unid=None, href=None, score=None, _configuration=None):  # noqa: E501
        """DocumentListEntry - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._modified = None
        self._unid = None
        self._href = None
        self._score = None
        self.discriminator = None

        if modified is not None:
            self.modified = modified
        if unid is not None:
            self.unid = unid
        if href is not None:
            self.href = href
        if score is not None:
            self.score = score

    @property
    def modified(self):
        """Gets the modified of this DocumentListEntry.  # noqa: E501

        The last modification date of the document.  # noqa: E501

        :return: The modified of this DocumentListEntry.  # noqa: E501
        :rtype: str
        """
        return self._modified

    @modified.setter
    def modified(self, modified):
        """Sets the modified of this DocumentListEntry.

        The last modification date of the document.  # noqa: E501

        :param modified: The modified of this DocumentListEntry.  # noqa: E501
        :type: str
        """

        self._modified = modified

    @property
    def unid(self):
        """Gets the unid of this DocumentListEntry.  # noqa: E501

        The universal ID of the document.  # noqa: E501

        :return: The unid of this DocumentListEntry.  # noqa: E501
        :rtype: str
        """
        return self._unid

    @unid.setter
    def unid(self, unid):
        """Sets the unid of this DocumentListEntry.

        The universal ID of the document.  # noqa: E501

        :param unid: The unid of this DocumentListEntry.  # noqa: E501
        :type: str
        """

        self._unid = unid

    @property
    def href(self):
        """Gets the href of this DocumentListEntry.  # noqa: E501

        The URL of the Document resource.  # noqa: E501

        :return: The href of this DocumentListEntry.  # noqa: E501
        :rtype: str
        """
        return self._href

    @href.setter
    def href(self, href):
        """Sets the href of this DocumentListEntry.

        The URL of the Document resource.  # noqa: E501

        :param href: The href of this DocumentListEntry.  # noqa: E501
        :type: str
        """

        self._href = href

    @property
    def score(self):
        """Gets the score of this DocumentListEntry.  # noqa: E501

        The search score if this entry is in a search response.  # noqa: E501

        :return: The score of this DocumentListEntry.  # noqa: E501
        :rtype: int
        """
        return self._score

    @score.setter
    def score(self, score):
        """Sets the score of this DocumentListEntry.

        The search score if this entry is in a search response.  # noqa: E501

        :param score: The score of this DocumentListEntry.  # noqa: E501
        :type: int
        """

        self._score = score

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DocumentListEntry, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DocumentListEntry):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DocumentListEntry):
            return True

        return self.to_dict() != other.to_dict()
