# coding: utf-8

"""
    IBM Domino Data API

    The data API provides access to any database for which it is enabled. The API represents databases, views, view entries, and documents in JSON format.  **Important**: This version of the OpenAPI spec (**data.yaml**) includes data API changes from the XPages Extension Library release 9.0.1.v09_02. This  includes new operations on attachments, agents and forms.  If you are using a version before 9.0.1.v09_02, consider using an earlier version of the spec.   # noqa: E501

    OpenAPI spec version: 9.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from dda.configuration import Configuration


class FolderOperations(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'add': 'list[str]',
        'remove': 'list[str]'
    }

    attribute_map = {
        'add': 'add',
        'remove': 'remove'
    }

    def __init__(self, add=None, remove=None, _configuration=None):  # noqa: E501
        """FolderOperations - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._add = None
        self._remove = None
        self.discriminator = None

        if add is not None:
            self.add = add
        if remove is not None:
            self.remove = remove

    @property
    def add(self):
        """Gets the add of this FolderOperations.  # noqa: E501

        Array of UNIDs of documents to add to the folder.  # noqa: E501

        :return: The add of this FolderOperations.  # noqa: E501
        :rtype: list[str]
        """
        return self._add

    @add.setter
    def add(self, add):
        """Sets the add of this FolderOperations.

        Array of UNIDs of documents to add to the folder.  # noqa: E501

        :param add: The add of this FolderOperations.  # noqa: E501
        :type: list[str]
        """

        self._add = add

    @property
    def remove(self):
        """Gets the remove of this FolderOperations.  # noqa: E501

        Array of UNIDs of documents to remove from the folder.  # noqa: E501

        :return: The remove of this FolderOperations.  # noqa: E501
        :rtype: list[str]
        """
        return self._remove

    @remove.setter
    def remove(self, remove):
        """Sets the remove of this FolderOperations.

        Array of UNIDs of documents to remove from the folder.  # noqa: E501

        :param remove: The remove of this FolderOperations.  # noqa: E501
        :type: list[str]
        """

        self._remove = remove

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FolderOperations, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FolderOperations):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FolderOperations):
            return True

        return self.to_dict() != other.to_dict()
