# coding: utf-8

"""
    IBM Domino Data API

    The data API provides access to any database for which it is enabled. The API represents databases, views, view entries, and documents in JSON format.  **Important**: This version of the OpenAPI spec (**data.yaml**) includes data API changes from the XPages Extension Library release 9.0.1.v09_02. This  includes new operations on attachments, agents and forms.  If you are using a version before 9.0.1.v09_02, consider using an earlier version of the spec.   # noqa: E501

    OpenAPI spec version: 9.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from dda.configuration import Configuration


class View(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'title': 'str',
        'folder': 'bool',
        'private': 'bool',
        'modified': 'str',
        'unid': 'str',
        'href': 'str'
    }

    attribute_map = {
        'title': '@title',
        'folder': '@folder',
        'private': '@private',
        'modified': '@modified',
        'unid': '@unid',
        'href': '@href'
    }

    def __init__(self, title=None, folder=None, private=None, modified=None, unid=None, href=None, _configuration=None):  # noqa: E501
        """View - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._title = None
        self._folder = None
        self._private = None
        self._modified = None
        self._unid = None
        self._href = None
        self.discriminator = None

        if title is not None:
            self.title = title
        if folder is not None:
            self.folder = folder
        if private is not None:
            self.private = private
        if modified is not None:
            self.modified = modified
        if unid is not None:
            self.unid = unid
        if href is not None:
            self.href = href

    @property
    def title(self):
        """Gets the title of this View.  # noqa: E501

        Title of the view or folder.  # noqa: E501

        :return: The title of this View.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this View.

        Title of the view or folder.  # noqa: E501

        :param title: The title of this View.  # noqa: E501
        :type: str
        """

        self._title = title

    @property
    def folder(self):
        """Gets the folder of this View.  # noqa: E501

        `false` for a view, `true` for a folder.   # noqa: E501

        :return: The folder of this View.  # noqa: E501
        :rtype: bool
        """
        return self._folder

    @folder.setter
    def folder(self, folder):
        """Sets the folder of this View.

        `false` for a view, `true` for a folder.   # noqa: E501

        :param folder: The folder of this View.  # noqa: E501
        :type: bool
        """

        self._folder = folder

    @property
    def private(self):
        """Gets the private of this View.  # noqa: E501

        `false` for shared, `true` for private.   # noqa: E501

        :return: The private of this View.  # noqa: E501
        :rtype: bool
        """
        return self._private

    @private.setter
    def private(self, private):
        """Sets the private of this View.

        `false` for shared, `true` for private.   # noqa: E501

        :param private: The private of this View.  # noqa: E501
        :type: bool
        """

        self._private = private

    @property
    def modified(self):
        """Gets the modified of this View.  # noqa: E501

        Last modification date and time for the view or folder.   # noqa: E501

        :return: The modified of this View.  # noqa: E501
        :rtype: str
        """
        return self._modified

    @modified.setter
    def modified(self, modified):
        """Sets the modified of this View.

        Last modification date and time for the view or folder.   # noqa: E501

        :param modified: The modified of this View.  # noqa: E501
        :type: str
        """

        self._modified = modified

    @property
    def unid(self):
        """Gets the unid of this View.  # noqa: E501

        Universal ID of the view or folder.  # noqa: E501

        :return: The unid of this View.  # noqa: E501
        :rtype: str
        """
        return self._unid

    @unid.setter
    def unid(self, unid):
        """Sets the unid of this View.

        Universal ID of the view or folder.  # noqa: E501

        :param unid: The unid of this View.  # noqa: E501
        :type: str
        """

        self._unid = unid

    @property
    def href(self):
        """Gets the href of this View.  # noqa: E501

        The URL of the corresponding view entry list resource.  # noqa: E501

        :return: The href of this View.  # noqa: E501
        :rtype: str
        """
        return self._href

    @href.setter
    def href(self, href):
        """Sets the href of this View.

        The URL of the corresponding view entry list resource.  # noqa: E501

        :param href: The href of this View.  # noqa: E501
        :type: str
        """

        self._href = href

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(View, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, View):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, View):
            return True

        return self.to_dict() != other.to_dict()
